<?php

namespace App\Filament\Resources;

use App\Filament\Resources\PageResource\Pages;
use App\Filament\Resources\PageResource\RelationManagers;
use App\Models\Page;
use Filament\Forms;
use Filament\Forms\Components\FileUpload;
use Filament\Forms\Components\KeyValue;
use Filament\Forms\Components\Repeater;
use Filament\Forms\Components\RichEditor;
use Filament\Forms\Components\Section;
use Filament\Forms\Components\Select;
use Filament\Forms\Components\Textarea;
use Filament\Forms\Components\TextInput;
use Filament\Forms\Components\Toggle;
use Filament\Forms\Form;
use Filament\Forms\Set;
use Illuminate\Support\Str;
use Filament\Resources\Resource;
use Filament\Tables;
use Filament\Tables\Columns\IconColumn;
use Filament\Tables\Columns\TextColumn;
use Filament\Tables\Table;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\SoftDeletingScope;
use Symfony\Contracts\Service\Attribute\Required;

class PageResource extends Resource
{
    protected static ?string $model = Page::class;

    protected static ?string $navigationIcon = 'heroicon-o-document';

    protected static ?string $navigationGroup = 'Content';

    public static function form(Form $form): Form
    {
        $pages = Page::Pluck('title', 'id')->toArray();

        return $form
            ->schema([

                Section::make('Page Information')
                    ->description('Add a new page')
                    ->schema([
                        TextInput::make('title')->label('Page Title')
                            ->required()
                            ->live(1)
                            ->columnSpanFull()
                            ->afterStateUpdated(fn (Set $set, ?string $state) => $set('slug', Str::slug($state))),
                        TextInput::make('slug')->required()->columnSpan(3),
                        Select::make('is_published')
                            ->options([
                                0 => 'Draft',
                                1 => 'Published'
                            ])
                            ->default(1)
                            ->required()
                            ->searchable()
                            ->label('Status')
                            ->columnSpan(1),
                        RichEditor::make('content')->label('Page Content')->columnSpanFull(),
                        FileUpload::make('page_image')
                            ->label('Custom Image (Optional)')
                            ->directory('media/pages')
                            ->columnSpanFull()
                            ->preserveFilenames()
                            ->image()
                            ->maxSize(2048),
                    ])
                    ->columns(4),

                Section::make('Customize Page')
                    ->description('Modifiy Page SEO and Meta Information')
                    ->schema([
                        KeyValue::make('meta')
                            ->label('Meta (Optional)')
                            ->keyPlaceholder('Name')
                            ->valuePlaceholder('Content')
                            ->reorderable(),
                        Select::make('parent')->options($pages)->label('Parents (Optional)'),
                        Textarea::make('custom_header')->rows(6)->label('Custom Header (Optional)'),
                    ]),



            ]);
    }

    public static function table(Table $table): Table
    {
        return $table
            ->columns([
                TextColumn::make('title')->searchable(),
                TextColumn::make('slug'),
                IconColumn::make('is_published')->label('Published')->boolean(),
                TextColumn::make('created_at')
                    ->label('Created At'),
            ])
            ->defaultSort('created_at', 'desc')
            ->filters([
                //
            ])
            ->actions([
                Tables\Actions\EditAction::make(),
            ])
            ->bulkActions([
                Tables\Actions\BulkActionGroup::make([
                    Tables\Actions\DeleteBulkAction::make(),
                ]),
            ]);
    }

    public static function getRelations(): array
    {
        return [
            //
        ];
    }

    public static function getPages(): array
    {
        return [
            'index' => Pages\ListPages::route('/'),
            'create' => Pages\CreatePage::route('/create'),
            'edit' => Pages\EditPage::route('/{record}/edit'),
        ];
    }
}
